<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <h3 class="text-center mb-3 mt-3">Danh sách người dùng đăng ký</h3>
        <button class="btn btn-success mt-2 mb-3">Thêm User</button>
        <table id="user-table" class="table table-bordered table-triped">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>First Name</th>
                    <th>Last Name</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>CustomerType</th>
                    <th>RegisterStatus</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>

    </div>


</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_DELETE_OK = 204;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_CREATE_OK = 201;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    var gColName = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
    const gCOL_ID = 0;
    const gCOL_FIRST_NAME = 1;
    const gCOL_LAST_NAME = 2;
    const gCOL_COUNTRY = 3;
    const gCOL_SUBJECT = 4;
    const gCOL_CUSTOMER_TYPE = 5;
    const gCOL_REGISTER_STATUS = 6;
    const gCOL_ACTION = 7;



    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onLoadPage();
        $("#user-table").on("click", ".btn-update", function () {
            getDataBtn(this);
        })
        onBtnDelete();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function fillDataTable(paramElement) {
        $("#user-table").DataTable({
            data: paramElement,
            columns: [
                { data: gColName[gCOL_ID] },
                { data: gColName[gCOL_FIRST_NAME] },
                { data: gColName[gCOL_LAST_NAME] },
                { data: gColName[gCOL_COUNTRY] },
                { data: gColName[gCOL_SUBJECT] },
                { data: gColName[gCOL_CUSTOMER_TYPE] },
                { data: gColName[gCOL_REGISTER_STATUS] },
                { data: gColName[gCOL_ACTION] },

            ],
            columnDefs: [
                {
                    targets: gCOL_ACTION,
                    defaultContent: "<button class='btn btn-success btn-update'>Sửa</button>" +
                        "<button class='ml-2 btn btn-danger btn-delete'>Xóa</button>"
                }
            ]
        })

    }
    function onLoadPage() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramRes) {
                fillDataTable(paramRes);
                console.log(paramRes);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })
    }
    function onBtnDelete() {
        $("#user-table").on("click", ".btn-delete", function () {
            getDataBtn(this);
        })
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getDataBtn(paramElement) {
        var vRow = $(paramElement).closest("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRow).data();

        console.log(vDataRow);

    }

</script>

</html>